#include <stdio.h>
#include <string.h>
#include "concat.h"
#include "dict.h"
#include "env.h"
#include "talloc.h"

Atom *
env2dict (char **env)
{
    int i;
    char *equal;
    Atom *result = NULL;

    if (env == NULL)
	return NULL;
    for (i = 0; env[i] != NULL; ++i) {
	if (equal = strchr (env[i], '=')) {
	    char *name = xstrndup (env[i], equal-env[i]);
	    result = define (result, name, string (equal+1));
	    free (name);
	}
	else
	    continue;
    }
    return result;
}

char **
dict2env (Atom *dict)
{
    Atom *ptr;
    int count = 1;
    char **result;
    int i;

    for (ptr = dict; !nullp (ptr); ptr=next(ptr))
	++count;
    i = 0;
    result = TALLOC(count+1, char *);
    for (ptr = dict; !nullp (ptr); ptr=next(ptr)) {
	Atom *entry = this (ptr);
	if (!nullp (entry) && !nullp(this(entry)) && !nullp(next(entry)))
	    result[i++] = concat (stringval (this (entry)), "=",
				  stringval (next (entry)), NULL);
    }
    result[i] = NULL;
    return result;
}

#ifdef TEST
main (int argc, char **argv, char **envp)
{
    Atom *dict = env2dict (envp);
    int i;
    char **foo;

    print (dict);
    foo = dict2env (dict);
    for (i = 0; foo[i]; ++i)
	printf ("%s\n", foo[i]);
}

#endif
