#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "global.h"
#include "concat.h"

struct global global;

/*
 * convert a C string consisting of URLs delimited by ","
 * to a List of Strings
 *
 * compare path2list in args.c
 */

static Atom *
urls2list (char *s)
{
    char *comma;

    if (s == NULL)
	return NULL;
    else if (*s == '\0')
	return cons (string (""), NULL);
    else if (comma = strchr (s, ',')) 
	return cons (stringn (s, comma-s), urls2list (comma+1));
    else
	return cons (string (s), NULL);
}

void
global_init (char *argv0)
{
    global.platform_attrs = NULL;
    global.platform_cpu = NULL;
    global.platform_os_name = NULL;
    global.platform_os_version = NULL;
    global.netbuild_arch = NULL;
    global.libpath = NULL;
    global.verbosity = 0;
    global.constraints = NULL;
    global.path_prefix = concat (getenv ("HOME"), "/NetBuild2", NULL);
    global.platform_filename = NULL;
    global.shared_lib_mode = SHARED_LOCAL;
    global.shared_dir = NULL;

    /* XXX need to put initial server list in a config file */
    if (getenv ("NB2_SERVER_LIST"))
	global.server_list = urls2list (getenv ("NB2_SERVER_LIST"));
    else
	global.server_list =
	    list (string ("http://www.netlib.org/netbuild/packages/"),
		  string ("http://www.cs.utk.edu/~moore/netbuild/packages/"),
		  NULL);

    global.liblist = NULL;
    global.required_libs = NULL;
    global.argv0 = strdup (argv0);
}
