#include <stdio.h>
#include "md5.h"

#define MD5_DIGEST_LENGTH (128/8)

void
nb_md5 (char *filename)
{
    FILE *fp;
    MD5_CTX c;
    unsigned char md[MD5_DIGEST_LENGTH];
    int i;
    static unsigned char buf[1024*16];

    if ((fp = fopen (filename, "r")) == NULL) {
	perror (filename);
	return;
    }
    MD5Init (&c);
    while (1) {
	i = fread (buf, sizeof (char), sizeof (buf), fp);
	if (i <= 0)
	    break;
	MD5Update (&c, buf, (unsigned long) i);
    }
    MD5Final (md, &c);

    printf ("MD5 (%s) = ", filename);
    for (i = 0; i < MD5_DIGEST_LENGTH; ++i)
	printf ("%02x", md[i]);
    printf ("\n");
    fclose (fp);
}
