#/bin/sh
os="`uname -s`"
#
# compare sysnames[] in ../nc/platform.c
#
case "$os" in
	AIX) os="aix";;
	CYGWIN*) os="cygwin";;
	Darwin) os="darwin";;
	IRIX64) os="irix64";;
	Linux) os="linux";;
	NetBSD) os="netbsd";;
	OSF1) os="osf1";;
	SunOS) os="sunos";;
	ULTRIX) os="ultrix";;
esac
#
# compare get_compile_os_info in ../nc/platform.c
#
case "$os" in
	aix)
		# XXX
		#
		# aix runs on other things besides powerpc, including old 
		# rs6000s, old RTs, ibm mainframes, and ia64.  also uname -m  
		# does not produce anything useful to us.  for now just 
		# assume powerpc 
		#
		#if /usr/sbin/lsattr -EHl proc0 | grep PowerPC >/dev/null ; then
		#	arch="powerpc";
		#fi
		arch="powerpc"
		;;
	darwin)
		# uname -m says something like "Power Macintosh"
		arch="`uname -p`";;
	irix64)
		# uname -m is too specific; we need the generic name
		arch="`uname -p`";;
	*)
		arch=`uname -m`
		case "$arch" in
        		i386) arch="ia32";;
        		i486) arch="ia32";;
        		i586) arch="ia32";;
        		i686) arch="ia32";;
        		sun4*) arch="sparc";;
			RISC) arch="mips";;
			VAX) arch="vax";;
		esac ;;
esac

echo $arch-$os
exit 0

# tested on
#
# various ia32-linux systems
# various ia32-netbsd systems
# powerpc-macos (macos x 10.2.6)
# mips-irix64 
# powerpc-aix
# sparc-sunos
# alpha-osf1
# 
