#include <stdio.h>
#include "dict.h"
#include "type.h"

Atom *
sort_candidates (Atom *dict, char *key)
{
    Atom *pivot_nvp;
    Atom *value;
    int pivot_val;
    int comp_val;
    Atom *less = NULL;
    Atom *equal = NULL;
    Atom *greater = NULL;

    do {
	if (nullp (dict))
	    return NULL;
	pivot_nvp = this (dict);
	dict = next (dict);
	value = nlookup (next (pivot_nvp), key);
#if 0
	printf ("\n\npivot value\n");
	print_atom (value);
	printf ("\n\n");
#endif
    } while (value == NULL || stringp (value) == 0);
    
    pivot_val = atoi (stringval (value));
    equal = cons (pivot_nvp, equal);

    if (nullp (dict))
	return equal;

    while (!nullp (dict)) {
	value = nlookup (next (this (dict)), key);
	
	if (value == NULL || !stringp (value))
	    goto next;

	comp_val = atoi (stringval (value));
	if (comp_val < pivot_val) {
#if 0
	    printf ("< comp_val = %d pivot_val = %d\n", comp_val, pivot_val);
#endif
	    less = cons (this (dict), less);
	}
	else if (comp_val > pivot_val) {
#if 0
	    printf ("> comp_val = %d pivot_val = %d\n", comp_val, pivot_val);
#endif
	    greater = cons (this (dict), greater);
	}
	else {
#if 0
	    printf ("= comp_val = %d pivot_val = %d\n", comp_val, pivot_val);
#endif
	    equal = cons (this (dict), equal);
	}
    next:
	dict = next (dict);
    }
#if 0
    printf ("\n\nprior to recursion:\n");
    printf ("less:\n");
    fprint_dict (stdout, less);
    printf ("equal:\n");
    fprint_dict (stdout, equal);
    printf ("greater:\n");
    fprint_dict (stdout, greater);
#endif
    less = sort_candidates (less, key);
    greater = sort_candidates (greater, key);
    return append (less, append (equal, greater));
}

